package dev.shadowsoffire.apotheosis.mixin;

package .tmp;

import dev.shadowsoffire.apotheosis.adventure.socket.ReactiveSmithingRecipe;
import javax.annotation.Nullable;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.ContainerLevelAccess;
import net.minecraft.world.inventory.ItemCombinerMenu;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.inventory.SmithingMenu;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.SmithingRecipe;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin({SmithingMenu.class})
public abstract class SmithingMenuMixin extends ItemCombinerMenu {
  @Shadow
  @Nullable
  private SmithingRecipe f_40242_;
  
  public SmithingMenuMixin(MenuType<?> p_39773_, int p_39774_, Inventory p_39775_, ContainerLevelAccess p_39776_) {
    super(p_39773_, p_39774_, p_39775_, p_39776_);
  }
  
  @Inject(at = {@At("HEAD")}, method = {"onTake"})
  protected void onTake(Player player, ItemStack stack, CallbackInfo ci) {
    SmithingRecipe smithingRecipe = this.f_40242_;
    if (smithingRecipe instanceof ReactiveSmithingRecipe) {
      ReactiveSmithingRecipe ext = (ReactiveSmithingRecipe)smithingRecipe;
      ext.onCraft(this.f_39769_, player, stack);
    } 
  }
}
